// Session Saver 0.2
// By Pike

var SessionSaverSettings = {

	prefService: null,
	
	onLoad: function()
	{
		// Setup object properties
		this.prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('sessionsaver.settings.');
		this.autoSaveButton = document.getElementById('autosave');
		this.autoLoadButton = document.getElementById('autoload');
		
		// Load initial status of Autosave button
		var autoSave = true;
		try
		{
			autoSave = this.prefService.getBoolPref('autosave');
		}
		catch (err) {}
		if (autoSave) this.autoSaveButton.checked = true;
		else this.autoSaveButton.checked = false;
		
		// Load initial status of Autoload button
		var autoLoad = true;
		try
		{
			autoLoad = this.prefService.getBoolPref('autoload');
		}
		catch (err) {}
		if (autoLoad) this.autoLoadButton.checked = true;
		else this.autoLoadButton.checked = false;
	},
	
	onAccept: function()
	{
		if (this.autoSaveButton.checked)
		{
			this.prefService.setBoolPref('autosave', true);
		}
		else
		{
			this.prefService.setBoolPref('autosave', false);
		}
		if (this.autoLoadButton.checked)
		{
			this.prefService.setBoolPref('autoload', true);
		}
		else
		{
			this.prefService.setBoolPref('autoload', false);
		}
	}
};
