// Work Offline 0.2
// By Pike

const WorkOfflineObserver = {

	observe: function(prefService, topic, pref)
	{
		if (pref.indexOf('offline') != -1)
		{
			var offline = false;
			try
			{
				offline = prefService.getBoolPref('offline');
			}
			catch (err) {}
			WorkOffline.updateMenuItem(offline);
		}
	}
};

var WorkOffline = {

	prefService: null,
	ioService: null,
	
	onLoad: function()
	{
		// Setup object properties
		this.prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('workoffline.');
		this.ioService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
		
		// Check offline pref
		var offline = false;
		try
		{
			offline = this.prefService.getBoolPref('offline');
		}
		catch (err) {}
		
		// Update menu item
		this.updateMenuItem(offline);
		
		// Update offline status
		this.ioService.offline = offline;
		
		// Set up preference observer (so each window is notified of a change in offline status)
		var prefBranch = this.prefService.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
		if (prefBranch)
		{
			prefBranch.addObserver('offline', WorkOfflineObserver, false);
		}
	},
	
	toggleOffline: function()
	{
		// Flip offline status
		var offline = document.getElementById('workoffline-offline').getAttribute('checked') ? true : false;
		this.ioService.offline = offline;
		this.prefService.setBoolPref('offline', offline);
	},
	
	updateMenuItem: function(offline)
	{
		if (offline)
		{
			document.getElementById('workoffline-offline').setAttribute('checked', 'true');
		}
		else
		{
			document.getElementById('workoffline-offline').removeAttribute('checked');
		}
	}
};

window.addEventListener('load', function() {WorkOffline.onLoad();}, false);
